program ChangeDisplay;
{$APPTYPE CONSOLE}

uses
  Windows,
  SysUtils;

var
  moderec: DEVMODE;
  i: Integer;
  W, H, C: Integer;

begin
  i := 0;
  if (ParamCount < 3) then
  begin
    Writeln('Usage: ChangeDisplay Width Height ColorBit');
    Writeln('Supported Display Modes');
    while(EnumDisplaySettings(nil, i, moderec)) do
    begin
      with moderec do
        Writeln(dmPelsWidth, '*', dmPelsHeight, '*', dmBitsPerPel);
      Inc(i);
    end;
    Exit;
  end;

  W := StrtoInt(ParamStr(1));
  H := StrtoInt(ParamStr(2));
  C := StrtoInt(ParamStr(3));
  while(EnumDisplaySettings(nil, i, moderec)) do
  begin
    with moderec do
    begin
      if (dmBitsPerPel = C) and (dmPelsWidth = W) and (dmPelsHeight = H) then
      begin
        dmFields := dmFields and (not DM_DISPLAYFLAGS) and (not DM_DISPLAYFREQUENCY);
        if ChangeDisplaySettings(moderec, 0) = DISP_CHANGE_SUCCESSFUL then
          Writeln('Changed Successfully');
        Exit;
      end;
    end;
    Inc(i);
  end;
end.
